



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>解决自定义Shiro.Realm扩展类不能用注解（@Resource或@Autowire）自动装配的问题</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">解决自定义Shiro.Realm扩展类不能用注解（@Resource或@Autowire）自动装配的问题</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 13:17:00 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>问题产生原因：加载Realm时其他Spring配置文件(xml)尚未加载，导致注入失败。</p>
<p>解决方法：编写一个设置类把注入工作提前完成。</p>
<div>
<pre class="prettyprint linenums">package com.xkt.shiro

import org.apache.shiro.realm.Realm;<br />
import org.apache.shiro.web.mgt.DefaultWebSecurityManager;<br />
import org.springframework.beans.BeansException;<br />
import org.springframework.context.ApplicationContext;<br />
import org.springframework.context.ApplicationContextAware;<br />
import org.springframework.context.annotation.Configuration;

/**<br />
 * 把securityManager和userRealm装配到ApplicationContext<br />
 */<br />
@Configuration<br />
public class ShiroConfig implements ApplicationContextAware {

    @Override<br />
    public void setApplicationContext(ApplicationContext ac) throws BeansException {<br />
        Realm userRealm = (Realm) ac.getBean("userRealm");<br />
        DefaultWebSecurityManager defaultWebSecurityManager = (DefaultWebSecurityManager) ac.getBean("securityManager");<br />
        defaultWebSecurityManager.setRealm(userRealm);<br />
    }<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qyoo28r.html">svn diff  详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kj5379.html">Java针对数据库增删改查代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdz7409.html">arduino 串口实时绘图&lpar;以mpu9250为例&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8oyyx5q.html">java位运算符介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93rkdr9.html">Spring的LoadTimeWeaver&lpar;代码织入&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8elk6eq.html">关于Task类</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw224zq.html">Android Studio NDK 学习之接受Java传入的字符串</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gme04l9.html">int integer string间的转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd1k4m8.html">POJ 2106  Boolean Expressions &lpar;布尔表达式求值&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1vlp79.html">hdu 3972 1 M possible</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj4dyz9.html">3527&colon; &lbrack;Zjoi2014&rsqb;力</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdp0oy9.html">hdu&lowbar;5790&lowbar;Prefix&lpar;trie&plus;主席树&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p50ny8.html">Dijkstra算法的二叉堆优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp60r39.html">Linux源码-等待队列注释</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpv630q.html">C&num;中的泛型化方法的实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgjkrm8.html">nodeJs和JavaScript的异同（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjng6j9.html">python 的基础  学习   第五天  基础数据类型的操作方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/96043r49.html">使用Asp&period;Net Core MVC 开发项目实践&lbrack;第五篇&colon;缓存的使用&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy27zd9.html">WordCloud词云包的安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy5g6x9.html">深入理解java虚拟机读书笔记--java内存区域和管理</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/2q7m3jgq.html">sqli篇-本着就了解安全本质的想法，尽可能的用通俗易懂的语言去解释安全漏洞问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/495xy668.html">HYSBZ 2038 莫队算法</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pjym79.html">Spring Boot</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8okrne9.html">html5拖拽事件 xhr2 实现文件上传 含进度条</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qn1z128.html">PAT Basic Level 1001</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvvm7xq.html">broadcasting Theano vs&period; Numpy</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlm3z19.html">Struts2深入学习：OGNL表达式原理</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2wzeoq.html">easyUI combobox 控件 使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qydkdxq.html">php实现文件上传与下载（中）</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2w4j3q.html">js loaclstorage和sessionstorage</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
